<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistanceReportItem_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfDistanceReportItem_v2 extends AbstractStructArrayBase
{
    /**
     * The DistanceReportItem_v2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DistanceReportItem_v2[]
     */
    public $DistanceReportItem_v2;
    /**
     * Constructor method for ArrayOfDistanceReportItem_v2
     * @uses ArrayOfDistanceReportItem_v2::setDistanceReportItem_v2()
     * @param \StructType\DistanceReportItem_v2[] $distanceReportItem_v2
     */
    public function __construct(array $distanceReportItem_v2 = array())
    {
        $this
            ->setDistanceReportItem_v2($distanceReportItem_v2);
    }
    /**
     * Get DistanceReportItem_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DistanceReportItem_v2[]|null
     */
    public function getDistanceReportItem_v2()
    {
        return isset($this->DistanceReportItem_v2) ? $this->DistanceReportItem_v2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDistanceReportItem_v2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDistanceReportItem_v2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDistanceReportItem_v2ForArrayConstraintsFromSetDistanceReportItem_v2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDistanceReportItem_v2DistanceReportItem_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfDistanceReportItem_v2DistanceReportItem_v2Item instanceof \StructType\DistanceReportItem_v2) {
                $invalidValues[] = is_object($arrayOfDistanceReportItem_v2DistanceReportItem_v2Item) ? get_class($arrayOfDistanceReportItem_v2DistanceReportItem_v2Item) : sprintf('%s(%s)', gettype($arrayOfDistanceReportItem_v2DistanceReportItem_v2Item), var_export($arrayOfDistanceReportItem_v2DistanceReportItem_v2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DistanceReportItem_v2 property can only contain items of type \StructType\DistanceReportItem_v2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DistanceReportItem_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem_v2[] $distanceReportItem_v2
     * @return \ArrayType\ArrayOfDistanceReportItem_v2
     */
    public function setDistanceReportItem_v2(array $distanceReportItem_v2 = array())
    {
        // validation for constraint: array
        if ('' !== ($distanceReportItem_v2ArrayErrorMessage = self::validateDistanceReportItem_v2ForArrayConstraintsFromSetDistanceReportItem_v2($distanceReportItem_v2))) {
            throw new \InvalidArgumentException($distanceReportItem_v2ArrayErrorMessage, __LINE__);
        }
        if (is_null($distanceReportItem_v2) || (is_array($distanceReportItem_v2) && empty($distanceReportItem_v2))) {
            unset($this->DistanceReportItem_v2);
        } else {
            $this->DistanceReportItem_v2 = $distanceReportItem_v2;
        }
        return $this;
    }
    /**
     * Add item to DistanceReportItem_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem_v2 $item
     * @return \ArrayType\ArrayOfDistanceReportItem_v2
     */
    public function addToDistanceReportItem_v2(\StructType\DistanceReportItem_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DistanceReportItem_v2) {
            throw new \InvalidArgumentException(sprintf('The DistanceReportItem_v2 property can only contain items of type \StructType\DistanceReportItem_v2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DistanceReportItem_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DistanceReportItem_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DistanceReportItem_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DistanceReportItem_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DistanceReportItem_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DistanceReportItem_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistanceReportItem_v2
     */
    public function getAttributeName()
    {
        return 'DistanceReportItem_v2';
    }
}
